VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCPUUsage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   ********************************************************************
'   Einstellungen
Option Explicit

'   ********************************************************************
'   zu implementierende Interfaces
Implements ICPUUsage

'   ********************************************************************
'   private Konstanten
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const HKEY_DYN_DATA = &H80000006
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))

'   ********************************************************************
'   private Auflistungen
Private Enum ErrorCodeEnum
    ERROR_SUCCESS = 0
End Enum

'   ********************************************************************
'   private API-Funktionen (fr ffentliche eine Methode schreiben!)
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long _
) As Long

Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long _
) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
    ByVal hKey As Long _
) As Long

'   ********************************************************************
'   private Variablen
Private hKey As Long
Private dwDataSize As Long
Private dwCpuUsage As Byte
Private dwType As Long

'   ********************************************************************
'   ffentliche Methoden
Public Function Query() As Long
    Call ICPUUsage_Query
End Function

'   ********************************************************************
'   Klassengebundene Methoden
Private Sub Initialize()
    Dim Result As ErrorCodeEnum
    
    '   start the counter by reading the value of the 'StartStat' key
    Result = RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StartStat", 0, KEY_ALL_ACCESS, hKey)
    
    If (Result <> ErrorCodeEnum.ERROR_SUCCESS) Then
        Debug.Print "Error while initializing counter, code '" & CStr(Result) & "'"
    Else
        dwDataSize = 4 'Length of Long
    
        Call RegQueryValueEx(hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize)
        Call RegCloseKey(hKey)
        
        'get current counter's value
        Result = RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StatData", 0, KEY_READ, hKey)
        If (Result <> ErrorCodeEnum.ERROR_SUCCESS) Then
            Debug.Print "Error while opening counter key, code '" & CStr(Result) & "'"
        End If
    End If
End Sub

Private Sub Terminate()
    Dim Result As ErrorCodeEnum
    
    Call RegCloseKey(hKey)
    
    'stopping the counter
    Result = RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StopStat", 0, KEY_ALL_ACCESS, hKey)
    If Result <> ErrorCodeEnum.ERROR_SUCCESS Then
        Debug.Print "Error while stopping counter"
    Else
        Call RegQueryValueEx(hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize)
        Call RegCloseKey(hKey)
    End If
End Sub

'   ********************************************************************
'   Implementierte Methoden
Private Function ICPUUsage_Query() As Long
'    dwDataSize = 4 'size of Long
    'Query the counter
    RegQueryValueEx hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize
    ICPUUsage_Query = CLng(dwCpuUsage)
End Function
